commit 3b57fc9ae5a9c7dd78c6b1b758ec5b582c689be6
Author: freddy77 <freddy77>
Date:   Fri Feb 6 10:11:08 2009 +0000

    remove file leak in unittests

diff --git a/ChangeLog b/ChangeLog
index 7e223ea..ad95872 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Fri Feb  6 11:10:35 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/dblib/unittests/common.c: remove file leak in unittests
+
 Thu Feb  5 09:49:08 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/dblib/unittests/done_handling.c src/dblib/unittests/rpc.c:
 	* src/dblib/unittests/t0011.c src/dblib/unittests/t0016.c:
@@ -1277,4 +1280,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2720 2009/02/05 08:49:45 freddy77 Exp $
+$Id: ChangeLog,v 1.2721 2009/02/06 10:11:08 freddy77 Exp $
diff --git a/src/dblib/unittests/common.c b/src/dblib/unittests/common.c
index a087112..58b6c1b 100644
--- a/src/dblib/unittests/common.c
+++ b/src/dblib/unittests/common.c
@@ -18,7 +18,7 @@
 
 #include <err.h>
 
-static char software_version[] = "$Id: common.c,v 1.26 2009/02/01 22:29:39 jklowden Exp $";
+static char software_version[] = "$Id: common.c,v 1.27 2009/02/06 10:11:09 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 typedef struct _tag_memcheck_t
@@ -90,6 +90,16 @@ tds_dirname(char* path)
 
 #endif
 
+char free_file_registered = 0;
+static void
+free_file(void)
+{
+	if (INPUT) {
+		fclose(INPUT);
+		INPUT = NULL;
+	}
+}
+
 int
 read_login_info(int argc, char **argv)
 {
@@ -215,6 +225,10 @@ read_login_info(int argc, char **argv)
 		fflush(stdout);
 		warnx("could not open SQL input file \"%s\"\n", sql_file);
 	}
+
+	if (!free_file_registered)
+		atexit(free_file);
+	free_file_registered = 1;
 	
 	printf("SQL text will be read from %s\n", sql_file);
 

